﻿expanded class
	STI_COMPLEX

inherit
	STS_COMPLEX
		rename
			a as real,
			b as imaginary
		redefine
			default_create,
			complex_anchor,
			real_anchor
		end

create
	default_create,
	make,
	make_from_real,
	make_from_native_integer,
	make_from_integer

convert
	make_from_real ({STS_REAL}),
	make_from_native_integer({INTEGER}),
	make_from_integer ({STS_INTEGER})

feature {NONE}

	default_create
		do
			a := Zero
			b := Zero
		ensure then
			real: a ≍ Zero
			imaginary: b ≍ Zero
		end

	make (a_real, a_imaginary: STS_REAL)
		do
			a := converted_real (a_real)
			b := converted_real (a_imaginary)
		ensure
			real: a ≍ a_real
			imaginary: b ≍ a_imaginary
		end

	make_from_real (x: STS_REAL)
		do
			make (x, Zero)
		ensure
			real: a ≍ x
			imaginary: b ≍ Zero
		end

	make_from_native_integer (v: INTEGER)
		do
			make (create {STI_REAL}.make_from_native_integer (v), Zero)
		ensure
			real: {STI_REAL}.same_value (a.value, {STI_REAL}.normalized_value (v))
			imaginary: b ≍ Zero
		end

	make_from_integer (i: STS_INTEGER)
		do
			make_from_native_integer (i.value)
		ensure
			real: {STI_REAL}.same_value (a.value, {STI_REAL}.normalized_value (i.value))
			imaginary: b ≍ Zero
		end

feature

	a: like real_anchor

	real: like real_anchor
		do
			Result := a
		end

	b: like real_anchor

	imaginary: like real_anchor
		do
			Result := b
		end

	Zero: STI_INTEGER
		once
		end

	One: STI_INTEGER
		once
			Result := 1
		end

	converted_real (x: STS_REAL): like real_anchor
		do
			if attached {like real_anchor} x as cx then
				Result := cx
			else
				Result := x
			end
		ensure
			class
			definition: Result ≍ x
		end

	complex_anchor: STI_COMPLEX
		do
			Result := Current
		end

	real_anchor: STI_REAL
		do
			Result := a
		end

end
