﻿expanded class
	STI_INTEGER

inherit
	STS_INTEGER
		redefine
			default_create,
			complex_anchor,
			real_anchor,
			integer_anchor
		end

create
	default_create,
	make,
	make_from_integer

convert
	make ({INTEGER}),
	make_from_integer ({STS_INTEGER}),
	as_real: {STI_REAL},
	as_complex: {STI_COMPLEX}

feature {NONE}

	default_create
		do
			value := 0
		ensure then
			value: value = 0
		end

	make (v: INTEGER)
		do
			value := normalized_value (v)
		ensure
			value: value = normalized_value (v)
		end

	make_from_integer (i: STS_INTEGER)
		do
			make (i.value)
		ensure
			value: value = normalized_value (i.value)
		end

feature

	real_value: REAL
		do
			Result := value
		end

	value: INTEGER

	Zero: STI_INTEGER
		once
		end

	One: STI_INTEGER
		once
			Result := 1
		end

	as_complex: like complex_anchor
		do
			create Result.make_from_integer (Current)
		ensure
			real: Result.a ≍ Current
			Imaginary: Result.b ≍ Zero
		end

	as_real: like real_anchor
		do
			create Result.make_from_integer (Current)
		ensure
			value: Result.value = real_value
		end

	real_normalized_value (v: REAL): REAL
		do
			Result := {STI_REAL}.normalized_value (v)
		ensure then
			class
			definition: Result = {STI_REAL}.normalized_value (v)
		end

	normalized_value (v: INTEGER): INTEGER
		do
			Result := v
		ensure then
			class
			definition: Result = v -- never mind.
		end

	complex_anchor: STI_COMPLEX
		do
			Result := Current
		end

	real_anchor: STI_REAL
		do
			Result := Current
		end

	integer_anchor: STI_INTEGER
		do
			Result := Current
		end

end
