﻿expanded class
	STI_REAL

inherit
	STS_REAL
		redefine
			default_create,
			complex_anchor,
			real_anchor
		end

create
	default_create,
	make,
	make_from_real,
	make_from_native_integer,
	make_from_integer

convert
	make ({REAL}),
	make_from_real ({STS_REAL}),
	make_from_native_integer ({INTEGER}),
	make_from_integer ({STS_INTEGER}),
	as_complex: {STI_COMPLEX}

feature {NONE}

	default_create
		do
			value := 0
		ensure then
			value: same_value (value, 0)
		end

	make (v: REAL)
		do
			value := normalized_value (v)
		ensure
			value: same_value (value, normalized_value (v))
		end

	make_from_real (x: STS_REAL)
		do
			make (x.value)
		ensure
			value: same_value (value, x.value)
		end

	make_from_native_integer (v: INTEGER)
		do
			make (v)
		ensure
			value: same_value (value, normalized_value (v))
		end

	make_from_integer (i: STS_INTEGER)
		do
			make_from_native_integer (i.value)
		ensure
			value: same_value (value, normalized_value (i.value))
		end

feature

	value: REAL

	Zero: STI_INTEGER
		once
		end

	One: STI_INTEGER
		once
			Result := 1
		end

	as_complex: like complex_anchor
		do
			create Result.make_from_real (Current)
		ensure
			real: Result.a ≍ Current
			Imaginary: Result.b ≍ Zero
		end

	normalized_value (v: REAL): REAL
		do
			Result := v
		ensure then
			class
			definition: same_value (Result, v) -- never mind.
		end

	complex_anchor: STI_COMPLEX
		do
			Result := Current
		end

	real_anchor: STI_REAL
		do
			Result := Current
		end

end
