﻿deferred class
	STS_REAL

inherit
	STS_COMPLEX
		rename
			a as identity alias "+", real as identity alias "+",
			b as zero, imaginary as zero
		end

feature

	value: REAL
		deferred
		end

	zero: like real_anchor
		deferred
		ensure then
			definition: Result.same_value (Result.value, 0)
		end

	one: like real_anchor
		deferred
		ensure then
			definition: Result.same_value (Result.value, 1)
		end

	equals alias "≍" (x: STS_REAL): BOOLEAN
		do
			Result := same_value (value, x.value)
		ensure
			definition: Result = same_value (value, x.value)
		end

	same_value (v1, v2: REAL): BOOLEAN
		do
			if v1.is_nan then
				Result := v2.is_nan
			else
				Result := v1 = v2
			end
		ensure
			class
			not_a_number: v1.is_nan implies Result = v2.is_nan
			number: not v1.is_nan implies Result = (v1 = v2)
		end

	normalized_value (v: REAL): REAL
		deferred
		ensure
			stable: same_value (normalized_value (Result), Result)
		end

invariant
	normalized: same_value (value, normalized_value (value))
	identity: same_value ((+ Current).value, value)

end
